LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


ENTITY debouncer IS PORT( 
      clk        : IN     std_logic;
	  input		 : IN 	  std_logic;
      output     : BUFFER std_logic);
END debouncer;


ARCHITECTURE main OF debouncer IS
   signal debounceCount: integer RANGE 0 TO 629375;
   
BEGIN
	debouncer: process(clk)
	begin
		if (clk'event and clk = '1') then
			if (input /= output) then
				if (debounceCount /= 629375) then
					debounceCount <= debounceCount + 1;
				end if;
	
				if (debounceCount = 629374) then
					output <= input;
				end if;
			else
				debounceCount <= 0;
			end if;
		end if;
	end process;
end main;

