LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


ENTITY segDecoder IS PORT( 
      value      : IN     std_logic_vector (3 DOWNTO 0);
      segDisplay : OUT    std_logic_vector (7 DOWNTO 0));
END segDecoder ;

--
ARCHITECTURE main OF segDecoder IS
BEGIN
   with value select
         segDisplay <= "11000000" when "0000",
                       "11111001" when "0001",
                       "10100100" when "0010",
                       "10110000" when "0011",
                       "10011001" when "0100",
                       "10010010" when "0101",
                       "10000010" when "0110",
                       "11011000" when "0111",
                       "10000000" when "1000",
                       "10010000" when "1001",
                       "10001000" when "1010",
                       "10000011" when "1011",
                       "11000110" when "1100",
                       "10100001" when "1101",
                       "10000110" when "1110",
                       "10001110" when "1111",
                       "11111111" when others; 
END main;
